/*===========================================================================

	Copyright  2007 Tea Tuar

	This material is provided "as is", with no warranty expressed or implied.
	Any use is at your own risk. Permission to use or copy this software for
	any purpose is hereby granted without fee, provided this notice is
	retained on all copies. Permission to modify the code and to distribute
	modified code is granted, provided a notice that the code was modified is
	included with the above copyright notice.

	http://dis.ijs.si/tea/research.htm

	===========================================================================

	Implementation file.

	file: demo_params.cpp
	author: Tea Tusar (tea.tusar@ijs.si)
	created: 16.02.2006
	last change: $date$

	===========================================================================
*/

#include "demo_params.h"
//---------------------------------------------------------------------------

DemoParams::DemoParams()
{
	m_pop_size = 10;
	m_max_eval = 20;
	//F and CR, set here, are only used, when not self-adapted (DEMO), ini InitPop&GetCandidate,
	//otherwise in InitPop&GetCandidate, self-adaptive values from DemoInd() constructor are used
	m_weight = /*0.3+0.4**/(double) rand() / RAND_MAX;
	m_cross_prob = /*0.3+0.2**/(double) rand() / RAND_MAX;

	//added by AlesZ
	minF=0.1;
	maxF=0.9;
	minCR=1.0/24;
	maxCR=0.9;
	//higher learn=smaller changes (learned good), smaller=search broader
	learnTau=0.5;

	strategyDE=7;

	strategyPrunning=1;//=DEMO orig

//	NP_size_factor=2;/// DemoAlg.cpp in FileStats.cpp
	NP_size_factor=1;/// DemoAlg.cpp in FileStats.cpp


//	appsetMaxGenerations=200;//keep individuals of last 200 generations
	//change: 28jan08-test
//	appsetMaxGenerations=20;//keep individuals of last 200 generations
	//change: 13mar08
	appsetMaxGenerations=1;//keep individuals of last 5 generations (=5*1600=8000)
	//change: 31mar08
//	appsetMaxGenerations=7;//keep individuals of min. last 2 generations (max=2*1600=3600)

}
//---------------------------------------------------------------------------

DemoParams::DemoParams(DemoParams& params)
{
	m_pop_size = params.m_pop_size;
	m_max_eval = params.m_max_eval;
	m_cross_prob = params.m_cross_prob;
	m_weight = params.m_weight;
}
//---------------------------------------------------------------------------

