/*===========================================================================

	Copyright  2007 Tea Tuar

	This material is provided "as is", with no warranty expressed or implied.
	Any use is at your own risk. Permission to use or copy this software for
	any purpose is hereby granted without fee, provided this notice is
	retained on all copies. Permission to modify the code and to distribute
	modified code is granted, provided a notice that the code was modified is
	included with the above copyright notice.

	http://dis.ijs.si/tea/research.htm

	===========================================================================

	Implementation file.

	file: demo_pop_nsga.cpp
	author: Tea Tusar (tea.tusar@ijs.si)
	created: 18.02.2006
	last change: $date$

	===========================================================================
*/

#include "demo_pop_nsga.h"
//#include <values>
//---------------------------------------------------------------------------

DemoPopNsga::DemoPopNsga()
	: DemoPop()
{
	m_elitism = false;
	m_elitism_r = 0.5;

	m_crow_dist.clear();
	m_ranks.clear();
}
//---------------------------------------------------------------------------

DemoPopNsga::~DemoPopNsga()
{
}
//---------------------------------------------------------------------------

vector<UINT> DemoPopNsga::SortPop()
{
	if (m_inds.size() == m_params->GetPopSize()) {
		vector<UINT> result;
		result.clear();
		for (UINT i = 0; i < m_inds.size(); i++)
			result.push_back(i);
		return result;
	}

	CalcFronts();
	if (m_elitism == false)
		return SortPopNsga();
	else
		return SortPopNsgaElitism();
}
//---------------------------------------------------------------------------

/*vector<UINT> DemoPopNsga::SortPop()
{

	UINT j = m_inds.size();
	if (j < 40) {
		for (UINT i = j; i < 40; i++) {
			DemoInd *ind = new DemoInd();
			*ind = *m_inds.at(0);
			m_inds.push_back(ind);
		}
	}

	m_inds.at(0)->SetCriterion(0, 417.016208);
	m_inds.at(0)->SetCriterion(1, 4.382109);
	m_inds.at(1)->SetCriterion(0, 700.226526);
	m_inds.at(1)->SetCriterion(1, 2.812059);
	m_inds.at(2)->SetCriterion(0, 587.320862);
	m_inds.at(2)->SetCriterion(1, 3.405485);
	m_inds.at(3)->SetCriterion(0, 1080.461291);
	m_inds.at(3)->SetCriterion(1, 0.926443);
	m_inds.at(4)->SetCriterion(0, 772.136782);
	m_inds.at(4)->SetCriterion(1, 2.593519);
	m_inds.at(5)->SetCriterion(0, 986.056006);
	m_inds.at(5)->SetCriterion(1, 1.663668);
	m_inds.at(6)->SetCriterion(0, 390.819778);
	m_inds.at(6)->SetCriterion(1, 4.850672);
	m_inds.at(7)->SetCriterion(0, 560.077864);
	m_inds.at(7)->SetCriterion(1, 3.737791);
	m_inds.at(8)->SetCriterion(0, 288.505795);
	m_inds.at(8)->SetCriterion(1, 5.395861);
	m_inds.at(9)->SetCriterion(0, 668.094514);
	m_inds.at(9)->SetCriterion(1, 3.170376);
	m_inds.at(10)->SetCriterion(0, 497.051448);
	m_inds.at(10)->SetCriterion(1, 3.782246);
	m_inds.at(11)->SetCriterion(0, 1303.469495);
	m_inds.at(11)->SetCriterion(1, 0.197552);
	m_inds.at(12)->SetCriterion(0, 565.794752);
	m_inds.at(12)->SetCriterion(1, 3.526819);
	m_inds.at(13)->SetCriterion(0, 687.666215);
	m_inds.at(13)->SetCriterion(1, 2.921114);
	m_inds.at(14)->SetCriterion(0, 962.548207);
	m_inds.at(14)->SetCriterion(1, 2.063564);
	m_inds.at(15)->SetCriterion(0, 418.254324);
	m_inds.at(15)->SetCriterion(1, 4.342344);
	m_inds.at(16)->SetCriterion(0, 552.744357);
	m_inds.at(16)->SetCriterion(1, 3.771252);
	m_inds.at(17)->SetCriterion(0, 1268.553373);
	m_inds.at(17)->SetCriterion(1, 0.212778);
	m_inds.at(18)->SetCriterion(0, 1335.854223);
	m_inds.at(18)->SetCriterion(1, 0.011623);
	m_inds.at(19)->SetCriterion(0, 714.631385);
	m_inds.at(19)->SetCriterion(1, 2.783844);

	m_inds.at(20)->SetCriterion(0, 908.504028);
	m_inds.at(20)->SetCriterion(1, 2.14933);
	m_inds.at(21)->SetCriterion(0, 561.805936);
	m_inds.at(21)->SetCriterion(1, 3.526819);
	m_inds.at(22)->SetCriterion(0, 720.314407);
	m_inds.at(22)->SetCriterion(1, 2.78371);
	m_inds.at(23)->SetCriterion(0, 655.067239);
	m_inds.at(23)->SetCriterion(1, 2.990582);
	m_inds.at(24)->SetCriterion(0, 673.117561);
	m_inds.at(24)->SetCriterion(1, 2.915512);
	m_inds.at(25)->SetCriterion(0, 423.110719);
	m_inds.at(25)->SetCriterion(1, 4.34803);
	m_inds.at(26)->SetCriterion(0, 1179.63785);
	m_inds.at(26)->SetCriterion(1, 1.277439);
	m_inds.at(27)->SetCriterion(0, 388.008811);
	m_inds.at(27)->SetCriterion(1, 4.951982);
	m_inds.at(28)->SetCriterion(0, 1092.238378);
	m_inds.at(28)->SetCriterion(1, 1.464672);
	m_inds.at(29)->SetCriterion(0, 631.631458);
	m_inds.at(29)->SetCriterion(1, 3.099079);
	m_inds.at(30)->SetCriterion(0, 1210.789252);
	m_inds.at(30)->SetCriterion(1, 0.709038);
	m_inds.at(31)->SetCriterion(0, 389.169847);
	m_inds.at(31)->SetCriterion(1, 4.858944);
	m_inds.at(32)->SetCriterion(0, 417.113071);
	m_inds.at(32)->SetCriterion(1, 4.962645);
	m_inds.at(33)->SetCriterion(0, 666.224776);
	m_inds.at(33)->SetCriterion(1, 2.95187);
	m_inds.at(34)->SetCriterion(0, 654.636396);
	m_inds.at(34)->SetCriterion(1, 3.178722);
	m_inds.at(35)->SetCriterion(0, 552.114418);
	m_inds.at(35)->SetCriterion(1, 3.55044);
	m_inds.at(36)->SetCriterion(0, 640.964957);
	m_inds.at(36)->SetCriterion(1, 3.170376);
	m_inds.at(37)->SetCriterion(0, 1303.469495);
	m_inds.at(37)->SetCriterion(1, 0.197552);
	m_inds.at(38)->SetCriterion(0, 1095.196629);
	m_inds.at(38)->SetCriterion(1, 1.077093);
	m_inds.at(39)->SetCriterion(0, 520.363886);
	m_inds.at(39)->SetCriterion(1, 4.294596);

	for (UINT i = 0; i < m_inds.size(); i++)
		m_inds.at(i)->SetViolation(0);

	CalcFronts();
	if (m_elitism == false)
		return SortPopNsga();
	else
		return SortPopNsgaElitism();
}*/
//---------------------------------------------------------------------------

vector<UINT> DemoPopNsga::SortPopNsga()
{
	vector<UINT> result;
	result.clear();

	UINT i, j;
	bool exact = false;
	UINT num_ind = 0;
	UINT count_entire = 0;

	do {
		num_ind += m_fronts.at(count_entire++).size();
		if (num_ind == m_params->GetPopSize())
			exact = true;
	}
	while (num_ind < m_params->GetPopSize());
	if (!exact)
		count_entire--;

	for (i = 0; i < count_entire; i++)
		for (j = 0; j < m_fronts.at(i).size(); j++)
			result.push_back(m_fronts.at(i).at(j));

	if (!exact) {
		//CalcCrowDistOld(count_entire);
		CalcCrowDist(count_entire);
		vector<double> crowding;
		crowding.clear();
		for (i = 0; i < m_fronts.at(count_entire).size(); i++) {
			crowding.push_back(-(double)m_crow_dist.at(m_fronts.at(count_entire).at(i)));
		}
		vector<UINT> indexes = GetSorted(crowding);

		i = 0;
		do {
			result.push_back(m_fronts.at(count_entire).at(indexes.at(i++)));
		}
		while (result.size() < m_params->GetPopSize());
	}

	return result;
}
//---------------------------------------------------------------------------

vector<UINT> DemoPopNsga::SortPopNsgaElitism()
{
	vector<UINT> result;
	result.clear();

	UINT i, j;
	UINT rest, used, num_fronts, num_available;
	num_fronts = m_fronts.size();

	vector<UINT> num_used_from_front;
	num_used_from_front.clear();
	for (i = 0; i < num_fronts; i++)
		num_used_from_front.push_back(0);

	rest = 0;
	used = 0;

	while (used < m_params->GetPopSize()) {
		for (i = 0; i < num_fronts; i++) {
			num_available = (UINT)ceil(m_inds.size() * (1 - m_elitism_r) *
				pow(m_elitism_r, i) / (1 - pow(m_elitism_r, num_fronts))) + rest;
			if (m_fronts.at(i).size() == num_used_from_front.at(i)) continue;
			if (m_fronts.at(i).size() <= num_available) {
				for (j = 0; j < m_fronts.at(i).size(); j++)
					result.push_back(m_fronts.at(i).at(num_used_from_front.at(i) + j));
				for (j = 0; j < m_fronts.at(i).size(); j++)
					num_used_from_front.at(i)++;
				rest = num_available - m_fronts.at(i).size();
			}
			else {
				CalcCrowDist(i);
				vector<double> crowding;
				crowding.clear();
				for (j = 0; j < m_fronts.at(i).size(); j++)
					crowding.push_back(-m_crow_dist.at(m_fronts.at(i).at(j)));
				vector<UINT> indexes = GetSorted(crowding);

				for (j = 0; j < num_available; j++)
					result.push_back(m_fronts.at(i).at(num_used_from_front.at(i) + indexes.at(j)));
				for (j = 0; j < num_available; j++)
					num_used_from_front.at(i)++;
				rest = 0;
			}
			if (used >= m_params->GetPopSize()) break;
		}
	}

	return result;
}
//---------------------------------------------------------------------------

void DemoPopNsga::CalcFronts()
{
	UINT i, j, k, l, dominate;
	vector< vector<UINT> > set;
	set.clear();
	vector<UINT> n;
	n.clear();
	m_fronts.clear();
	vector<UINT> tmp_set;
	vector<UINT> tmp_front;

	tmp_front.clear();
	for (i = 0; i < m_inds.size(); i++) {
		tmp_set.clear();
		n.push_back(0);
		m_ranks.push_back(0);
		for (j = 0; j < m_inds.size(); j++) {
			if (i == j)
				continue;
			dominate = m_probl->GetDomination(m_inds.at(i), m_inds.at(j));
			if (dominate == g_domin_first)
				tmp_set.push_back(j);
			else if (dominate == g_domin_second)
				n.at(i)++;
		}
		set.push_back(tmp_set);
		if (n.at(i) == 0) {
			m_ranks.at(i) = 0;
			tmp_front.push_back(i);
		}
	}
	m_fronts.push_back(tmp_front);

	k = 0;
	while (!m_fronts.at(k).empty()) {
		tmp_front.clear();
		for (i = 0; i < m_fronts.at(k).size(); i++)
			for (j = 0; j < set.at(m_fronts.at(k).at(i)).size(); j++) {
				n.at(set.at(m_fronts.at(k).at(i)).at(j))--;
				if (n.at(set.at(m_fronts.at(k).at(i)).at(j)) == 0)
					tmp_front.push_back(set.at(m_fronts.at(k).at(i)).at(j));
			}
		k++;
		if (k == m_inds.size()) break;
		m_fronts.push_back(tmp_front);
		for (l = 0; l < tmp_front.size(); l++)
			m_ranks.at(tmp_front.at(l)) = k;
	}
}
//---------------------------------------------------------------------------

void DemoPopNsga::CalcCrowDist(UINT front_num)
{
	UINT i, j, k;
	vector<UINT> front = m_fronts.at(front_num);

	m_crow_dist.clear();
	for (i = 0; i < m_inds.size(); i++)
		m_crow_dist.push_back(0);

	vector<double> sort_vec;
	vector<UINT> indexes;
	for (j = 0; j < m_probl->GetNumFunc(); j++) {
		sort_vec.clear();
		for (i = 0; i < front.size(); i++)
			sort_vec.push_back(m_inds.at(front.at(i))->GetCriterion(j));
		indexes = GetSorted(sort_vec);
		m_crow_dist.at(front.at(indexes.at(0))) += MAXINT;
		m_crow_dist.at(front.at(indexes.at(indexes.size() - 1))) += MAXINT;

		if (fabs(
				m_inds.at(front.at(indexes.at(0)))->GetCriterion(j) -
				m_inds.at(front.at(indexes.at(indexes.size() - 1)))->GetCriterion(j)
				) < g_eq_prec)
			{
				for (i = 1; i < indexes.size() - 1; i++)
					m_crow_dist.at(front.at(indexes.at(i))) += MAXINT;
			}

		else
			for (i = 1; i < indexes.size() - 1; i++) {
				m_crow_dist.at(front.at(indexes.at(i))) +=
					(m_inds.at(front.at(indexes.at(i + 1)))->GetCriterion(j) -
					 m_inds.at(front.at(indexes.at(i - 1)))->GetCriterion(j)) /
					(m_inds.at(front.at(indexes.at(indexes.size() - 1)))->GetCriterion(j) -
					 m_inds.at(front.at(indexes.at(0)))->GetCriterion(j));
			}
	}

	double copy_sum;
	vector< vector<UINT> > copies;
	vector<UINT> tmp_copy;

	RestoreCrowdDistVals(front, copy_sum, copies, tmp_copy);

	for (i = 0; i < front.size(); i++) {
		copy_sum = 0;
		k = copies.at(i).size();
		if (k > 1) {

			for (j = 0; j < k; j++) {
				copy_sum += m_crow_dist.at(front.at(copies.at(i).at(j)));
			}

			m_crow_dist.at(front.at(copies.at(i).at(0))) = copy_sum;
			for (j = 1; j < k; j++) {
				m_crow_dist.at(front.at(copies.at(i).at(j))) = 0;
			}

			oneFor(i,j,k,tmp_copy,copies);
			tmp_copy.clear();
			tmp_copy.push_back(i);
			copies.at(i) = tmp_copy;
		}
	}
	/*for (i = 0; i < m_inds.size(); i++) {
		cout << m_inds.at(i)->GetIndCritString();
		cout << m_crow_dist.at(i) << endl;
	} */
}

void DemoPopNsga::oneFor(UINT &i, UINT &j, UINT&k, vector<UINT> &tmp_copy, vector< vector<UINT> > &copies) {
	for (j = 1; j < k; j++) {
		tmp_copy.clear();
		cout << "1" <<endl;
		vector<UINT>& c=copies.at(i);
		cout << "1.5:j=" <<j<<", size="<<c.size()<<", i="<<i<<", k=" << k <<endl;
		tmp_copy.push_back(c.at(j));//tu je napaka
		cout << "2" <<endl;
		copies.at(copies.at(i).at(j)) = tmp_copy;
		cout << "3" <<endl;
	}
}

void DemoPopNsga::RestoreCrowdDistVals(vector<UINT> &front, double &copy_sum, vector< vector<UINT> > &copies, vector<UINT> &tmp_copy) {
	// Restore the crowding distance values for all copies:
	int i,j,k;

	copies.clear();
	for (i = 0; i < front.size(); i++) {
		tmp_copy.clear();
		for (j = 0; j < front.size(); j++) {
			if ((i == j) || (m_probl->IsEqual(m_inds.at(front.at(i))->GetCriteria(),
			     m_inds.at(front.at(j))->GetCriteria()))) {
				     tmp_copy.push_back(j);
			     }
		}
		copies.push_back(tmp_copy);
	}
}
//---------------------------------------------------------------------------


