/*===========================================================================

	Copyright  2007 Tea Tuar

	This material is provided "as is", with no warranty expressed or implied.
	Any use is at your own risk. Permission to use or copy this software for
	any purpose is hereby granted without fee, provided this notice is
	retained on all copies. Permission to modify the code and to distribute
	modified code is granted, provided a notice that the code was modified is
	included with the above copyright notice.

	http://dis.ijs.si/tea/research.htm

	===========================================================================

	Header file.

	Defines the structure DemoSortItem and function GetSorted() used for sorting
	and the structure E and function my_terminate() used for throwing exceptions.

	file: demo_utilities.h
	author: Tea Tusar (tea.tusar@ijs.si)
	created: 19.02.2006
	last change: $date$

	===========================================================================
*/

#ifndef demo_utilitiesH
#define demo_utilitiesH
//---------------------------------------------------------------------------

#include "demo_params.h"
//---------------------------------------------------------------------------

/** A structure used for sorting. */
struct DemoSortItem
{
	/** Index of the item. */
	UINT m_index;

	/** Value of the item - the value according to which the items will be
	sorted. */
	double m_value;

	/** Structure constructor. */
	DemoSortItem() {};

	/** Structure constructor. */
	DemoSortItem(UINT index, double value) {
		m_index = index;
		m_value = value;
	};

	/** Comparison operator. */
	bool operator<(const DemoSortItem &sort_item) {
		return (m_value < sort_item.m_value);
	};
};
//---------------------------------------------------------------------------

/** The function sortes the values in ascendent order.
params: values is the vector of values to be sorted
returns: a vector of indexes of the sorted vector */
vector<UINT> GetSorted(vector<double> &values);
//---------------------------------------------------------------------------

/** A structure used for throwing exceptions. */
struct E
{
	/** Error message. */
	string error;

	/** Structure constructor. */
	E(string arg);
};
//---------------------------------------------------------------------------

/** The function sets the text to be output before abnormal termination. */
void my_terminate();
//---------------------------------------------------------------------------

/** The function returns the value of x in the yes/no string form.
params: x the boolean to be converted into string
returns: "yes" or "no" (depending on x)
*/
string GetBoolStringYN(bool x);

/** The function returns the value of x in the 1/0 string form.
params: x the boolean to be converted into string
returns: "1" or "0" (depending on x)
*/
string GetBoolString01(bool x);
//---------------------------------------------------------------------------

/** The function is an interface to the real random
params: x for the [0,x] bounds
returns: random number between [0,x]
*/
unsigned long random(unsigned long x);

#endif

