/*===========================================================================

	Copyright  2007 Tea Tuar

	This material is provided "as is", with no warranty expressed or implied.
	Any use is at your own risk. Permission to use or copy this software for
	any purpose is hereby granted without fee, provided this notice is
	retained on all copies. Permission to modify the code and to distribute
	modified code is granted, provided a notice that the code was modified is
	included with the above copyright notice.

	http://dis.ijs.si/tea/research.htm

	===========================================================================

	Implementation file.

	file: file.cpp
	author: Tea Tusar (tea.tusar@ijs.si)
	created: 20.02.2006
	last change: $date$

	===========================================================================
*/

#include "file.h"
//---------------------------------------------------------------------------

const UINT g_mode_off = 0;
const UINT g_mode_overwrite = 1;
const UINT g_mode_append = 2;
//---------------------------------------------------------------------------

void File::SetName(string name)
	{m_name = name;}
//---------------------------------------------------------------------------

File::File()
	: m_f()
{
	m_mode = g_mode_off;
	m_name = "file.txt";
}
//---------------------------------------------------------------------------

File::~File()
{
	m_f.close();
}
//---------------------------------------------------------------------------

void File::InitFile()
{
	if (m_mode == g_mode_overwrite)
		m_f.open(m_name.c_str(), fstream::out);
	else if (m_mode == g_mode_append)
		m_f.open(m_name.c_str(), fstream::app);
}
//---------------------------------------------------------------------------

void File::Output(string str)
{
	if (m_mode != g_mode_off) {
		m_f << str;
		m_f.flush();
	}
}
//---------------------------------------------------------------------------

string File::GetModeString()
{
	string result;

	switch(m_mode) {
		case g_mode_off: result = "off"; break;
		case g_mode_overwrite: result = "overwrite"; break;
		case g_mode_append: result = "append"; break;
	}
	return result;
}
//---------------------------------------------------------------------------

