/*===========================================================================

	Copyright  2007 Tea Tuar

	This material is provided "as is", with no warranty expressed or implied.
	Any use is at your own risk. Permission to use or copy this software for
	any purpose is hereby granted without fee, provided this notice is
	retained on all copies. Permission to modify the code and to distribute
	modified code is granted, provided a notice that the code was modified is
	included with the above copyright notice.

	http://dis.ijs.si/tea/research.htm

	===========================================================================

	Header file.

	Defines the class File.

	file: file.h
	author: Tea Tusar (tea.tusar@ijs.si)
	created: 20.02.2006
	last change: $date$

	===========================================================================
*/

#ifndef fileH
#define fileH
//---------------------------------------------------------------------------

#include "demo_params.h"
//---------------------------------------------------------------------------

/** File opening modes. */
extern const UINT g_mode_off;
extern const UINT g_mode_overwrite;
extern const UINT g_mode_append;
//---------------------------------------------------------------------------

class File
{
private:
	/** File stream. */
	ofstream m_f;

	/** File name. */
	string m_name;

	/** File opening mode. */
	UINT m_mode;

public:
	void SetName(string name);
	inline void SetMode(UINT mode) {m_mode = mode;};

	inline string GetName() {return m_name;};
	inline bool IsOff() {return (m_mode == g_mode_off);};

	/** Class constructor. */
	File();

	/** Class destructor. */
	~File();

	/** Initialization function opens the file in the given mode. */
	void InitFile();

	/** The function outputs the string to the filestream, if the mode is not
	set to g_mode_off.
	params: str is the string to be output*/
	void Output(string str);

	/** Function returns the mode in string form.
	returns: the opening mode in string form*/
	string GetModeString();
};
//---------------------------------------------------------------------------
#endif



