/***************************************************************************
 *   Copyright (C) 2007 by Aleš Zamuda, Tea Tušar (IJS)                    *
 *   ales.zamuda@uni-mb.si, tea.tusar@ijs.si                               *
 *                                                                         *
 *   Permission is hereby granted, free of charge, to any person obtaining *
 *   a copy of this software and associated documentation files (the       *
 *   "Software"), to deal in the Software without restriction, including   *
 *   without limitation the rights to use, copy, modify, merge, publish,   *
 *   distribute, sublicense, and/or sell copies of the Software, and to    *
 *   permit persons to whom the Software is furnished to do so, subject to *
 *   the following conditions:                                             *
 *                                                                         *
 *   The above copyright notice and this permission notice shall be        *
 *   included in all copies or substantial portions of the Software.       *
 *                                                                         *
 *   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,       *
 *   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF    *
 *   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.*
 *   IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR     *
 *   OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, *
 *   ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR *
 *   OTHER DEALINGS IN THE SOFTWARE.                                       *
 ***************************************************************************/
#include "problfuncec09.h"
#include "cec09.h"

// #include <math.h>
#include <cmath>
//OLD: 3.14159265358979
#define PI  3.1415926535897932384626433832795


ProblFunCec09::ProblFunCec09()
{
}


ProblFunCec09::~ProblFunCec09()
{
}

void ProblFunCec09::InitProblem()
{
	m_num_eval=0;
	m_var_min.clear();
	m_var_max.clear();
	m_var_disc.clear();

	m_func_lower.clear();
	m_func_upper.clear();
	m_num_constraints=0;
	m_num_feat = 0;

	if (m_function == g_prob_fun_UF1) {
		m_num_func = 2;//2,3(8,9,10)
		m_num_var = 30;//30,10,30

		m_var_min.push_back(0);
		m_var_max.push_back(1);

		for (UINT i = 0; i < m_num_var-1; i++) {
			m_var_min.push_back(-1);
			m_var_max.push_back(1);
		}
		for (UINT i = 0; i < m_num_var; i++)
			m_var_disc.push_back(0);
	}
	//-------------------------------------------------
	else if (m_function == g_prob_fun_UF2) {
		m_num_func = 2;
		m_num_var = 30;

		m_var_min.push_back(0);
		m_var_max.push_back(1);

		for (UINT i = 0; i < m_num_var-1; i++) {
			m_var_min.push_back(-1);
			m_var_max.push_back(1);
		}
		for (UINT i = 0; i < m_num_var; i++)
			m_var_disc.push_back(0);
	}
	else if (m_function == g_prob_fun_UF3) {
		m_num_func = 2;
		m_num_var = 30;

		m_var_min.push_back(0);
		m_var_max.push_back(1);

		for (UINT i = 0; i < m_num_var-1; i++) {
			m_var_min.push_back(0);
			m_var_max.push_back(1);
		}
		for (UINT i = 0; i < m_num_var; i++)
			m_var_disc.push_back(0);
	}
	else if (m_function == g_prob_fun_UF4) {
		m_num_func = 2;
		m_num_var = 30;

		m_var_min.push_back(0);
		m_var_max.push_back(1);

		for (UINT i = 0; i < m_num_var-1; i++) {
			m_var_min.push_back(-2);
			m_var_max.push_back(2);
		}
		for (UINT i = 0; i < m_num_var; i++)
			m_var_disc.push_back(0);
	}
	else if (m_function == g_prob_fun_UF5) {
		m_num_func = 2;
		m_num_var = 30;

		m_var_min.push_back(0);
		m_var_max.push_back(1);

		for (UINT i = 0; i < m_num_var-1; i++) {
			m_var_min.push_back(-1);
			m_var_max.push_back(1);
		}
		for (UINT i = 0; i < m_num_var; i++)
			m_var_disc.push_back(0);
	}
	else if (m_function == g_prob_fun_UF6) {
		m_num_func = 2;
		m_num_var = 30;

		m_var_min.push_back(0);
		m_var_max.push_back(1);

		for (UINT i = 0; i < m_num_var-1; i++) {
			m_var_min.push_back(-1);
			m_var_max.push_back(1);
		}
		for (UINT i = 0; i < m_num_var; i++)
			m_var_disc.push_back(0);
	}
	else if (m_function == g_prob_fun_UF7) {
		m_num_func = 2;
		m_num_var = 30;

		m_var_min.push_back(0);
		m_var_max.push_back(1);

		for (UINT i = 0; i < m_num_var-1; i++) {
			m_var_min.push_back(-1);
			m_var_max.push_back(1);
		}
		for (UINT i = 0; i < m_num_var; i++)
			m_var_disc.push_back(0);
	}
	else if (m_function == g_prob_fun_UF8) {
		m_num_func = 3;
		m_num_var = 30;

		m_var_min.push_back(0);
		m_var_max.push_back(1);
		m_var_min.push_back(0);
		m_var_max.push_back(1);

		for (UINT i = 0; i < m_num_var-2; i++) {
			m_var_min.push_back(-2);
			m_var_max.push_back(2);
		}
		for (UINT i = 0; i < m_num_var; i++)
			m_var_disc.push_back(0);
	}
	else if (m_function == g_prob_fun_UF9) {
		m_num_func = 3;
		m_num_var = 30;

		m_var_min.push_back(0);
		m_var_max.push_back(1);
		m_var_min.push_back(0);
		m_var_max.push_back(1);

		for (UINT i = 0; i < m_num_var-2; i++) {
			m_var_min.push_back(-2);
			m_var_max.push_back(2);
		}
		for (UINT i = 0; i < m_num_var; i++)
			m_var_disc.push_back(0);
	}
	else if (m_function == g_prob_fun_UF10) {
		m_num_func = 3;
		m_num_var = 30;

		m_var_min.push_back(0);
		m_var_max.push_back(1);
		m_var_min.push_back(0);
		m_var_max.push_back(1);

		for (UINT i = 0; i < m_num_var-2; i++) {
			m_var_min.push_back(-2);
			m_var_max.push_back(2);
		}
		for (UINT i = 0; i < m_num_var; i++)
			m_var_disc.push_back(0);
	}
	else if (m_function == g_prob_fun_CF1) {
		m_num_func = 2;
		m_num_var = 10;
		m_num_constraints = 1;

		m_var_min.push_back(0);
		m_var_max.push_back(1);

		for (UINT i = 0; i < m_num_var-1; i++) {
			m_var_min.push_back(0);
			m_var_max.push_back(1);
		}
		for (UINT i = 0; i < m_num_var; i++)
			m_var_disc.push_back(0);
	}
	else if (m_function == g_prob_fun_CF2) {
		m_num_func = 2;
		m_num_var = 10;
		m_num_constraints = 1;

		m_var_min.push_back(0);
		m_var_max.push_back(1);

		for (UINT i = 0; i < m_num_var-1; i++) {
			m_var_min.push_back(-1);
			m_var_max.push_back(1);
		}
		for (UINT i = 0; i < m_num_var; i++)
			m_var_disc.push_back(0);
	}
	else if (m_function == g_prob_fun_CF3) {
		m_num_func = 2;
		m_num_var = 10;
		m_num_constraints = 1;

		m_var_min.push_back(0);
		m_var_max.push_back(1);

		for (UINT i = 0; i < m_num_var-1; i++) {
			m_var_min.push_back(-2);
			m_var_max.push_back(2);
		}
		for (UINT i = 0; i < m_num_var; i++)
			m_var_disc.push_back(0);
	}
	else if (m_function == g_prob_fun_CF4) {
		m_num_func = 2;
		m_num_var = 10;
		m_num_constraints = 1;

		m_var_min.push_back(0);
		m_var_max.push_back(1);

		for (UINT i = 0; i < m_num_var-1; i++) {
			m_var_min.push_back(-2);
			m_var_max.push_back(2);
		}
		for (UINT i = 0; i < m_num_var; i++)
			m_var_disc.push_back(0);
	}
	else if (m_function == g_prob_fun_CF5) {
		m_num_func = 2;
		m_num_var = 10;
		m_num_constraints = 1;

		m_var_min.push_back(0);
		m_var_max.push_back(1);

		for (UINT i = 0; i < m_num_var-1; i++) {
			m_var_min.push_back(-2);
			m_var_max.push_back(2);
		}
		for (UINT i = 0; i < m_num_var; i++)
			m_var_disc.push_back(0);
	}
	else if (m_function == g_prob_fun_CF6) {
		m_num_func = 2;
		m_num_var = 10;
		m_num_constraints = 2;

		m_var_min.push_back(0);
		m_var_max.push_back(1);

		for (UINT i = 0; i < m_num_var-1; i++) {
			m_var_min.push_back(-2);
			m_var_max.push_back(2);
		}
		for (UINT i = 0; i < m_num_var; i++)
			m_var_disc.push_back(0);
	}
	else if (m_function == g_prob_fun_CF7) {
		m_num_func = 2;
		m_num_var = 10;
		m_num_constraints = 2;

		m_var_min.push_back(0);
		m_var_max.push_back(1);

		for (UINT i = 0; i < m_num_var-1; i++) {
			m_var_min.push_back(-2);
			m_var_max.push_back(2);
		}
		for (UINT i = 0; i < m_num_var; i++)
			m_var_disc.push_back(0);
	}
	else if (m_function == g_prob_fun_CF8) {
		m_num_func = 3;
		m_num_var = 10;
		m_num_constraints = 1;

		m_var_min.push_back(0);
		m_var_max.push_back(1);
		m_var_min.push_back(0);
		m_var_max.push_back(1);

		for (UINT i = 0; i < m_num_var-2; i++) {
			m_var_min.push_back(-4);
			m_var_max.push_back(4);
		}
		for (UINT i = 0; i < m_num_var; i++)
			m_var_disc.push_back(0);
	}
	else if (m_function == g_prob_fun_CF9) {
		m_num_func = 3;
		m_num_var = 10;
		m_num_constraints = 1;

		m_var_min.push_back(0);
		m_var_max.push_back(1);
		m_var_min.push_back(0);
		m_var_max.push_back(1);

		for (UINT i = 0; i < m_num_var-2; i++) {
			m_var_min.push_back(-2);
			m_var_max.push_back(2);
		}
		for (UINT i = 0; i < m_num_var; i++)
			m_var_disc.push_back(0);
	}
	else if (m_function == g_prob_fun_CF10) {
		m_num_func = 3;
		m_num_var = 10;
		m_num_constraints = 1;

		m_var_min.push_back(0);
		m_var_max.push_back(1);
		m_var_min.push_back(0);
		m_var_max.push_back(1);

		for (UINT i = 0; i < m_num_var-2; i++) {
			m_var_min.push_back(-2);
			m_var_max.push_back(2);
		}
		for (UINT i = 0; i < m_num_var; i++)
			m_var_disc.push_back(0);
	}
	else if (m_function == g_prob_fun_R2_DTLZ2_M5) {
		m_num_func = 5;
		m_num_var = 30;

		double min[]={-1.773,-1.846,-1.053,-2.370,-1.603,-1.878,-1.677,-0.935,-1.891,-0.964,-0.885,-1.690,-2.235,-1.541,-0.720,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000};

		double max[]={1.403,1.562,2.009,0.976,1.490,1.334,1.074,2.354,1.462,2.372,2.267,1.309,0.842,1.665,2.476,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000};

		for (UINT i = 0; i < m_num_var; i++) {
			m_var_min.push_back(min[i]);
			m_var_max.push_back(max[i]);
		}
		for (UINT i = 0; i < m_num_var; i++)
			m_var_disc.push_back(0);
	}
	else if (m_function == g_prob_fun_R2_DTLZ3_M5) {
		m_num_func = 5;
		m_num_var = 30;

		double min[]={-1.773,-1.846,-1.053,-2.370,-1.603,-1.878,-1.677,-0.935,-1.891,-0.964,-0.885,-1.690,-2.235,-1.541,-0.720,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000};

		double max[]={1.403,1.562,2.009,0.976,1.490,1.334,1.074,2.354,1.462,2.372,2.267,1.309,0.842,1.665,2.476,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000,1.000};

		for (UINT i = 0; i < m_num_var; i++) {
			m_var_min.push_back(min[i]);
			m_var_max.push_back(max[i]);
		}
		for (UINT i = 0; i < m_num_var; i++)
			m_var_disc.push_back(0);
	}
	else if (m_function == g_prob_fun_D30_WFG1_M5) {
		m_num_func = 5;
		m_num_var = 30;

		for (UINT i = 0; i < m_num_var; i++) {
			m_var_min.push_back(0);
			m_var_max.push_back(2*(i+1));
		}
		for (UINT i = 0; i < m_num_var; i++)
			m_var_disc.push_back(0);
	}
	else throw("No such function for CEC09 -- fix the ini file!");
	//	ProblFun::InitProblem();
}
//---------------------------------------------------------------------------

void ProblFunCec09::Evaluate(DemoInd *ind)
{
//	if (GetNumEval() % 10000 == 0) {
//		cout << "\revaluating individual " << GetNumEval() << flush;
//	}

	//initialize criteria vector
	if (ind->GetCriteria().empty())
		ind->GetCriteria().resize(m_num_func);
	if (ind->GetConstraints().empty())
		ind->GetConstraints().resize(m_num_constraints);

	if (m_function == g_prob_fun_UF1) CalcUF1(ind);
	else if (m_function == g_prob_fun_UF2) CalcUF2(ind);
	else if (m_function == g_prob_fun_UF3) CalcUF3(ind);
	else if (m_function == g_prob_fun_UF4) CalcUF4(ind);
	else if (m_function == g_prob_fun_UF5) CalcUF5(ind);
	else if (m_function == g_prob_fun_UF6) CalcUF6(ind);
	else if (m_function == g_prob_fun_UF7) CalcUF7(ind);
	else if (m_function == g_prob_fun_UF8) CalcUF8(ind);
	else if (m_function == g_prob_fun_UF9) CalcUF9(ind);
	else if (m_function == g_prob_fun_UF10) CalcUF10(ind);
	else if (m_function == g_prob_fun_CF1) CalcCF1(ind);
	else if (m_function == g_prob_fun_CF2) CalcCF2(ind);
	else if (m_function == g_prob_fun_CF3) CalcCF3(ind);
	else if (m_function == g_prob_fun_CF4) CalcCF4(ind);
	else if (m_function == g_prob_fun_CF5) CalcCF5(ind);
	else if (m_function == g_prob_fun_CF6) CalcCF6(ind);
	else if (m_function == g_prob_fun_CF7) CalcCF7(ind);
	else if (m_function == g_prob_fun_CF8) CalcCF8(ind);
	else if (m_function == g_prob_fun_CF9) CalcCF9(ind);
	else if (m_function == g_prob_fun_CF10) CalcCF10(ind);
	else if (m_function == g_prob_fun_R2_DTLZ2_M5) CalcR2_DTLZ2_M5(ind);
	else if (m_function == g_prob_fun_R2_DTLZ3_M5) CalcR2_DTLZ3_M5(ind);
	else if (m_function == g_prob_fun_D30_WFG1_M5) CalcWFG1_M5(ind);
	else ProblFun::Evaluate(ind);
}

void ProblFunCec09::CalcUF1(DemoInd *ind) {
	CEC09::UF1(&ind->GetGenes()[0], &ind->GetCriteria()[0], m_num_var);
}

void ProblFunCec09::CalcUF2(DemoInd *ind) {
	CEC09::UF2(&ind->GetGenes()[0], &ind->GetCriteria()[0], m_num_var);
}

void ProblFunCec09::CalcUF3(DemoInd *ind) {
	CEC09::UF3(&ind->GetGenes()[0], &ind->GetCriteria()[0], m_num_var);
}

void ProblFunCec09::CalcUF4(DemoInd *ind) {
	CEC09::UF4(&ind->GetGenes()[0], &ind->GetCriteria()[0], m_num_var);
}

void ProblFunCec09::CalcUF5(DemoInd *ind) {
	CEC09::UF5(&ind->GetGenes()[0], &ind->GetCriteria()[0], m_num_var);
}

void ProblFunCec09::CalcUF6(DemoInd *ind) {
	CEC09::UF6(&ind->GetGenes()[0], &ind->GetCriteria()[0], m_num_var);
}

void ProblFunCec09::CalcUF7(DemoInd *ind) {
	CEC09::UF7(&ind->GetGenes()[0], &ind->GetCriteria()[0], m_num_var);
}

void ProblFunCec09::CalcUF8(DemoInd *ind) {
	CEC09::UF8(&ind->GetGenes()[0], &ind->GetCriteria()[0], m_num_var);
}

void ProblFunCec09::CalcUF9(DemoInd *ind) {
	CEC09::UF9(&ind->GetGenes()[0], &ind->GetCriteria()[0], m_num_var);
}

void ProblFunCec09::CalcUF10(DemoInd *ind) {
	CEC09::UF10(&ind->GetGenes()[0], &ind->GetCriteria()[0], m_num_var);
}

void ProblFunCec09::CalcCF1(DemoInd *ind) {
	CEC09::CF1(&ind->GetGenes()[0], &ind->GetCriteria()[0], &ind->GetConstraints()[0], m_num_var);
	combineConstraintViolations(ind);
}

void ProblFunCec09::CalcCF2(DemoInd *ind) {
	CEC09::CF2(&ind->GetGenes()[0], &ind->GetCriteria()[0], &ind->GetConstraints()[0], m_num_var);
	combineConstraintViolations(ind);
}

void ProblFunCec09::CalcCF3(DemoInd *ind) {
	CEC09::CF3(&ind->GetGenes()[0], &ind->GetCriteria()[0], &ind->GetConstraints()[0], m_num_var);
	combineConstraintViolations(ind);
}

void ProblFunCec09::CalcCF4(DemoInd *ind) {
	CEC09::CF4(&ind->GetGenes()[0], &ind->GetCriteria()[0], &ind->GetConstraints()[0], m_num_var);
	combineConstraintViolations(ind);
}

void ProblFunCec09::CalcCF5(DemoInd *ind) {
	CEC09::CF5(&ind->GetGenes()[0], &ind->GetCriteria()[0], &ind->GetConstraints()[0], m_num_var);
	combineConstraintViolations(ind);
}

void ProblFunCec09::CalcCF6(DemoInd *ind) {
	CEC09::CF6(&ind->GetGenes()[0], &ind->GetCriteria()[0], &ind->GetConstraints()[0], m_num_var);
	combineConstraintViolations(ind);
}

void ProblFunCec09::CalcCF7(DemoInd *ind) {
	CEC09::CF7(&ind->GetGenes()[0], &ind->GetCriteria()[0], &ind->GetConstraints()[0], m_num_var);
	combineConstraintViolations(ind);
}

void ProblFunCec09::CalcCF8(DemoInd *ind) {
	CEC09::CF8(&ind->GetGenes()[0], &ind->GetCriteria()[0], &ind->GetConstraints()[0], m_num_var);
	combineConstraintViolations(ind);
}

void ProblFunCec09::CalcCF9(DemoInd *ind) {
	CEC09::CF9(&ind->GetGenes()[0], &ind->GetCriteria()[0], &ind->GetConstraints()[0], m_num_var);
	combineConstraintViolations(ind);
}

void ProblFunCec09::CalcCF10(DemoInd *ind) {
	CEC09::CF10(&ind->GetGenes()[0], &ind->GetCriteria()[0], &ind->GetConstraints()[0], m_num_var);
	combineConstraintViolations(ind);
}

void ProblFunCec09::CalcR2_DTLZ2_M5(DemoInd *ind) {
	CEC09::R2_DTLZ2_M5(&ind->GetGenes()[0], &ind->GetCriteria()[0], m_num_var, m_num_func);
}

void ProblFunCec09::CalcR2_DTLZ3_M5(DemoInd *ind) {
	CEC09::R2_DTLZ3_M5(&ind->GetGenes()[0], &ind->GetCriteria()[0], m_num_var, m_num_func);
}

void ProblFunCec09::CalcWFG1_M5(DemoInd *ind) {
	CEC09::WFG1_M5(&ind->GetGenes()[0], &ind->GetCriteria()[0], m_num_var, m_num_func);
}

void ProblFunCec09::combineConstraintViolations(DemoInd *ind) {
	double g=0;
	double *c=&ind->GetConstraints()[0];
	bool geAll=true;
	for (int i = 0; i < m_num_constraints; i++) {
		if (c[i]< -1E-6)geAll=false;
		g+=abs(c[i]);//*c[i];
	}
	//IGD trick
	if (geAll) g=0;
	g/=m_num_constraints;//save the average value
	ind->SetViolation(g);
}

