/***************************************************************************
 *   Copyright (C) 2007 by Aleš Zamuda, Tea Tušar (IJS)   *
 *   ales.zamuda@uni-mb.si, tea.tusar@ijs.si   *
 *                                                                         *
 *   Permission is hereby granted, free of charge, to any person obtaining *
 *   a copy of this software and associated documentation files (the       *
 *   "Software"), to deal in the Software without restriction, including   *
 *   without limitation the rights to use, copy, modify, merge, publish,   *
 *   distribute, sublicense, and/or sell copies of the Software, and to    *
 *   permit persons to whom the Software is furnished to do so, subject to *
 *   the following conditions:                                             *
 *                                                                         *
 *   The above copyright notice and this permission notice shall be        *
 *   included in all copies or substantial portions of the Software.       *
 *                                                                         *
 *   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,       *
 *   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF    *
 *   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. *
 *   IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR     *
 *   OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, *
 *   ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR *
 *   OTHER DEALINGS IN THE SOFTWARE.                                       *
 ***************************************************************************/
#ifndef PROBLFUNCEC09_H
#define PROBLFUNCEC09_H

#include "probl_fun.h"

/**
*	@author Aleš Zamuda <ales.zamuda@uni-mb.si>
 * This class contains the problem functions for CEC09 problem suite,
 * which is copyrighted by other authors too -- see technical report
 * for performance assessment of MOO at CEC09.
*/
class ProblFunCec09 : public ProblFun {
public:
	ProblFunCec09();
	~ProblFunCec09();

	/** Initialization function sets the parameters of the problem. */
	void InitProblem();

	/** Function calls the evaluation of the current individual on a CEC07
	 * test function.
	params: ind the current individual
	*/
	void Evaluate(DemoInd *ind);

	void combineConstraintViolations(DemoInd *ind);
	void CalcUF1(DemoInd *ind);
	void CalcUF2(DemoInd *ind);
	void CalcUF3(DemoInd *ind);
	void CalcUF4(DemoInd *ind);
	void CalcUF5(DemoInd *ind);
	void CalcUF6(DemoInd *ind);
	void CalcUF7(DemoInd *ind);
	void CalcUF8(DemoInd *ind);
	void CalcUF9(DemoInd *ind);
	void CalcUF10(DemoInd *ind);
	void CalcCF1(DemoInd *ind);
	void CalcCF2(DemoInd *ind);
	void CalcCF3(DemoInd *ind);
	void CalcCF4(DemoInd *ind);
	void CalcCF5(DemoInd *ind);
	void CalcCF6(DemoInd *ind);
	void CalcCF7(DemoInd *ind);
	void CalcCF8(DemoInd *ind);
	void CalcCF9(DemoInd *ind);
	void CalcCF10(DemoInd *ind);
	void CalcR2_DTLZ2_M5(DemoInd *ind);
	void CalcR2_DTLZ3_M5(DemoInd *ind);
	void CalcWFG1_M5(DemoInd *ind);
};

#endif
